# Object practice exercise defining a class to represent a date
# Aaron Bauer, CS 111, Fall 2021
class Date:
    def __init__(self, year, month, day):
        self.year = year
        self.month = month
        self.day = day

    def __repr__(self):
        return str(self.year) + "/" + str(self.month) + "/" + str(self.day)

    def __eq__(self, other):
        # two Dates are equal if all their instance variables are equal
        return self.year == other.year and self.month == other.month and self.day == other.day

    def __gt__(self, other):
        if self.year > other.year:
            return True
        if self.year == other.year:
            if self.month > other.month:
                return True
            if self.month == other.month:
                return self.day > other.day
        return False

    def __ge__(self, other):
        # now that we have equals and greater than implemented
        # we can easily do greater than or equal to
        return self > other or self == other


d1 = Date(2021, 10, 31)
d2 = Date(2021, 11, 5)
d3 = Date(1988, 12, 1)
d4 = Date(2030, 1, 1)

print(d1)  # should print 2021/10/31
print(d1 == Date(2021, 10, 31))  # should print True
print(d1 > d2)  # should print False
print(d1 < d3)  # should print False
print(d4 >= d2)  # should print True
